/* Copyright (C) 2002 / 2003 AFE-GmdG */

/* Es _DARF_ nur Input.h includiert werden, weitere Header werden dort eingebunden. */
#include "Input.h"

/*
  Konstructor:
  In einem Konstructor sollten nur Membervariablen initialisiert werden. Ausfhrbarer Code
  zur Initialisierung gehrt in eine eigene Funktion, z.B. Init(). Dort steht dann auch
  schon ein gltiger this-Zeiger zur Verfgung - hier knnte er sich durchaus noch ndern.
*/
CInput::CInput(void) {
  m_hInstance=NULL;
  m_hWnd=NULL;
  m_lpGameLoopDemo=NULL;
}

/* Destructor, macht hier nichts */
CInput::~CInput(void) {
}

/*
  Init initialisiert die Input Klasse und gibt false zurck, wenn die Klasse schon
  Initialisiert wurde. Im Platz fr weitere Initialisierungen sollte DirectInput
  eingerichtet werden.
*/
BOOL CInput::Init(HINSTANCE hInstance, HWND hWnd, CGameLoopDemo *GameLoopDemo) {
  if(!hInstance||!hWnd||!GameLoopDemo||m_hInstance)
    return(FALSE);
  m_hInstance=hInstance;
  m_hWnd=hWnd;
  m_lpGameLoopDemo=GameLoopDemo;
  /*
  Platz fr weitere Initialisierungen...
  */
  return(TRUE);
}

VOID CInput::Release() {
  delete this;
}

/*
  Funktioniert nach dem gleichen Prinzip wie CGameLoopDemo::Render() - siehe dort
*/
DWORD CInput::PollInput() {
  // Diese Funktion luft in einem eigenem Thread.
  WaitForSingleObject(m_lpGameLoopDemo->GetInputMutex(), INFINITE);
  while(WaitForSingleObject(m_lpGameLoopDemo->GetRunMutex(), 10L)==WAIT_TIMEOUT) {
    /*
    Platz fr den Input-Poll
    */
  }
  ReleaseMutex(m_lpGameLoopDemo->GetInputMutex());
  return(0);
}
