/* Copyright (C) 2002 / 2003 AFE-GmdG */

#ifndef _INPUT_H // Prfe, ob dieser Header nicht schon andersweitig eingebunden wurde
#define _INPUT_H

/* Standard Windows Header */
#include <windows.h>

/* Header, die von GameLoopDemo.cpp bentigt werden */
// Derzeit keine

class CGameLoopDemo; // Vorwrtsdeklaration einer Klasse

/* Die Klasse Input */
class CInput {
private:
  HINSTANCE m_hInstance;
  HWND m_hWnd;
  CGameLoopDemo *m_lpGameLoopDemo;

public:
  CInput(void);
  virtual ~CInput(void);

  BOOL Init(HINSTANCE hInstance, HWND hWnd, CGameLoopDemo *GameLoopDemo);
  VOID Release();
  DWORD PollInput();
};

#include "GameLoopDemo.h" // Die Klasse CGameLoopDemo mu noch gltig gemacht werden.

#endif // _INPUT_H

/*
  Info:
  Die Vorwrtsdeklaration der Klasse ist notwendig, damit ich die Klasse
  als Membervariable Benutzen kann. Wrde ich an dieser Stelle GameLoopDemo.h
  vor der Klasse CInput Includieren, ergibt sich folgendes Problem:

  Beim Kompilieren von Input.cpp:
  Include "Input.h"
    Include "GameLoopDemo.h"
      Include "Input.h" // Zurckgewiesen durch #ifndef
    Variable *m_lpGameLoopDemo in CInput ist gltig
  Alles OK

  Beim Kompilieren von GameLoopDemo.cpp:
  Include "GameLoopDemo.h"
    Include "Input.h"
      Include "GameLoopDemo.h" // Zurckgewiesen durch #ifndef
    Variable m_lpGameLoopDemo in CInput ist ungltig, da die Klasse CGameLoopDemo noch nicht bekannt ist

  Im Wechselspiel der Klassen tritt auch noch die Variable *m_lpInput aus CGameLoopDemo
  zu Tage - dort das gleiche Problem in einer Anderen Reihnfolge.
*/




